<%

'----------------------------------------------------------------------------'
'ASP Util Library                                                            '
'Verso 2.4, atualizada em Junho de 2003                                     '
'                                                                            '
'Autor...: Fbio G. Silva                                                    '
'Email...: fabio@b2web.com.br                                                '
'Site....: www11.brinkster.com/fabiogsilva                                   '
'                                                                            '
'Esta biblioteca pode ser usada e distribuda livremente.                    '
'As rotinas foram testadas, mas no h nenhuma garantia de que funcionam     '
'corretamente ou de que no causam danos.                                    '
'----------------------------------------------------------------------------'


'//////////////////////////////////////////////////////////////////////////////

' Contedo da verso atual:
'
'   -> AspSelf                  'Retorna o caminho relativo do script atual
'   -> CreateFolder             'Cria uma pasta
'   -> CurrentFolder            'Retorna o caminho fsico da pasta atual
'   -> DateCheck                'Verifica se uma expresso de data  vlida
'   -> DateFormat               'Formata uma expresso de data em uma string
'   -> DeleteFile               'Deleta um arquivo
'   -> DeleteFolder             'Deleta uma pasta
'   -> Die                      'Imprime uma mensagem e mata o script
'   -> DirCount                 'Calcula o nmero de subpastas, arquivos e o espao total em uma pasta
'   -> ereg                     'Teste de expresso regular sensvel a caixa
'   -> eregi                    'Teste de expresso regular no sensvel a caixa
'   -> eregi_replace            'Substituio por expresso regular sensvel a caixa
'   -> ereg_replace             'Substituio de expresso regular no sensvel a caixa
'   -> FileCountLines           'Conta o nmero de linhas em um arquivo
'   -> FileExists               'Checa se um arquivo existe
'   -> FolderExists             'Checa se uma pasta existe
'   -> GetFile                  'Obtm um arquivo e retorna um objeto File
'   -> GetFileExt               'Retorna a extenso de um nome de arquivo
'   -> GetFileName              'Retorna o nome do arquivo em um caminho
'   -> GetFileProps             'Retorna um objeto dicionrio com as propriedades do arquivo
'   -> GetFolder                'Obtm uma pasta e retorna um objeto Folder
'   -> GetLinks                 'Retorna uma array contento todos os links <A> de uma string HTML
'   -> GetRelativePath          'Mapeia o caminho relativo para um arquivo a partir da pasta atual
'   -> GetTitle                 'Retorna o texto contido na tag <TITLE>
'   -> Hex2Int                  'Converte uma string hexadecimal em nmero
'   -> HTMLDecode               'Decodifica uma string HTML
'   -> Implode                  'Transforma uma array em string
'   -> JsBack                   'Imprime um JavaScript alert() seguido de history.back() e mata o script
'   -> JsClose                  'Imprime um JavaScript alert() seguido de window.close() e mata o script
'   -> JsGo                     'Imprime um JavaScript alert() seguido de redirecionamento e mata o script
'   -> MapRoot                  'Mapeia o caminho relativo da pasta atual at a raiz do site
'   -> NoScripts                'Remove blocos de script ASP, PHP, JavaScript e CSS
'   -> NumberFormat             'Formata um nmero para SQL
'   -> OpenFile                 'Abre um arquivo e retorna um objeto TextStream
'   -> ReadBinary               'L um arquivo no modo binrio
'   -> ReadDir                  'L todos os nomes de subpastas e arquivos dentro de uma pasta
'   -> ReadFile                 'L um arquivo no modo texto
'   -> StripTags                'Remove todas as tags HTML
'   -> TrimChop                 'Remove seqncias de caracteres brancos de dentro da string
'   -> UnEscape                 'Decodifica uma string de URL
'   -> WriteFile                'Escreve uma string em um arquivo


'Unidade de segundo do VBScript
Const VB_SECOND = 1.15740767796524E-05


Function ereg(ByVal Expr, ByVal Varn)
	Dim Regex
	Set Regex = New RegExp
	Regex.Pattern = Expr
	Regex.IgnoreCase = False
	Regex.Global = True
	ereg = Regex.Test(Varn)
	Set Regex = Nothing
End Function

Function eregi(ByVal Expr, ByVal Varn)
	Dim Regex
	Set Regex = New RegExp
	Regex.Pattern = Expr
	Regex.IgnoreCase = True
	Regex.Global = True
	eregi = Regex.Test(Varn)
	Set Regex = Nothing
End Function

Function ereg_replace(ByVal Expr, ByVal Subs, ByVal Varn)
	Dim Regex
	Set Regex = New RegExp
	Regex.Pattern = Expr
	Regex.IgnoreCase = False
	Regex.Global = True
	ereg_replace = Regex.Replace(Varn, Subs)
	Set Regex = Nothing
End Function

Function eregi_replace(ByVal Expr, ByVal Subs, ByVal Varn)
	Dim Regex
	Set Regex = New RegExp
	Regex.Pattern = Expr
	Regex.IgnoreCase = True
	Regex.Global = True
	eregi_replace = Regex.Replace(Varn, Subs)
	Set Regex = Nothing
End Function


'Abre um arquivo.
'O FileName pode ser um caminho absoluto ou relativo.
Function OpenFile(ByVal FileName, ByVal oMode, ByVal Create)
	
	Dim FSO, F
	Set FSO = Server.CreateObject("Scripting.FileSystemObject")
	
	On Error Resume Next
	
	If Mid(FileName, 2, 1) <> ":" Then
	  FileName = Server.MapPath(FileName)
	End If
	If Err Then Err.Clear
	
	Set F = FSO.OpenTextFile(FileName, oMode, Create)
	
	If Err Then
		Err.Clear
		On Error GoTo 0
		Set FSO = Nothing
		Set OpenFile = Nothing
		Exit Function
	End If
	
	On Error GoTo 0
	
	Set OpenFile = F
	Set FSO = Nothing
	
End Function


'L um arquivo no modo texto.
'O FileName pode ser um caminho absoluto ou relativo.
Function ReadFile(ByVal FileName)
  
  On Error Resume Next
  
  If Mid(FileName, 2, 1) <> ":" Then
    FileName = Server.MapPath(FileName)
  End If
  If Err Then Err.Clear
  
  On Error GoTo 0
  
	Dim F
	Set F = OpenFile(FileName, 1, False)
	
	If F Is Nothing Then
		ReadFile = ""
		Exit Function
	End If
	
	If Not F.AtEndOfStream Then
		ReadFile = F.ReadAll
	Else
		ReadFile = ""
	End If
	
	F.Close
	Set F = Nothing
	
End Function


'Salva uma string em um arquivo, sobrescrevendo o arquivo se ele existir.
'O FileName pode ser um caminho absoluto ou relativo.
Function WriteFile(ByVal FileName, ByRef Varn)
  
  On Error Resume Next
  
  If Mid(FileName, 2, 1) <> ":" Then
    FileName = Server.MapPath(FileName)
  End If
  If Err Then Err.Clear
  
  On Error GoTo 0
   
	Dim F
	Set F = OpenFile(FileName, 2, True)
	
	If F Is Nothing Then
		WriteFile = False
		Exit Function
	End If
	
	On Error Resume Next
	
	F.Write Varn
	If Err Then
		Err.Clear
		F.Close
		On Error GoTo 0
		WriteFile = False
		Exit Function
	End If
	
	On Error GoTo 0
	
	F.Close
	Set F = Nothing
	WriteFile = True
	
End Function


'L um arquivo no modo binrio.
'O FileName pode ser um caminho absoluto ou relativo.
Function ReadBinary(ByVal FileName)
  
  On Error Resume Next
  
  If Mid(FileName, 2, 1) <> ":" Then
    FileName = Server.MapPath(FileName)
  End If
  If Err Then Err.Clear
  
  On Error GoTo 0
  
	Dim Strm
	Set Strm = Server.CreateObject("Adodb.Stream")
	Strm.Type = 1  'Binary
	Strm.Open
	
	On Error Resume Next
	
	Strm.LoadFromFile FileName
	
	If Err Then
		Err.Clear
		Set Strm = Nothing
		ReadBinary = Null
		On Error GoTo 0
		Exit Function
	End If
	
	On Error GoTo 0
	
	ReadBinary = Strm.Read
	Strm.Close
	Set Strm = Nothing
	
End Function


'Deleta um arquivo.
'O Filename pode ser um caminho absoluto ou relativo.
Public Sub DeleteFile(ByVal FileName)
	
	On Error Resume Next
  If Mid(FileName, 2, 1) <> ":" Then
    FileName = Server.MapPath(FileName)
  End If
  If Err Then Err.Clear
  On Error GoTo 0
	
	Dim FSO
	Set FSO = Server.CreateObject("Scripting.FileSystemObject")
	If FSO.FileExists(FileName) Then
		FSO.DeleteFile FileName
	End If
	
	Set FSO = Nothing
	
End Sub


'Deleta uma pasta.
'O DirName pode ser um caminho absoluto ou relativo.
Public Sub DeleteFolder(ByVal DirName)

	On Error Resume Next
  If Mid(DirName, 2, 1) <> ":" Then
    DirName = Server.MapPath(DirName)
  End If
  If Err Then Err.Clear
  On Error GoTo 0
	
	Dim FSO
	Set FSO = Server.CreateObject("Scripting.FileSystemObject")
	
	On Error Resume Next
	If FSO.FolderExists(DirName) Then
		FSO.DeleteFolder DirName
	End If
	On Error GoTo 0
	
	Set FSO = Nothing
	
End Sub


'Checa se um arquivo existe.
'O FileName pode ser um caminho absoluto ou relativo.
Public Function FileExists(ByVal FileName)

	On Error Resume Next
  If Mid(FileName, 2, 1) <> ":" Then
    FileName = Server.MapPath(FileName)
  End If	
  On Error GoTo 0
	
	Dim fso
	Set fso = Server.CreateObject("Scripting.FileSystemObject")
	FileExists = fso.FileExists(FileName)
	Set fso = Nothing
	
End Function


'Checa se uma pasta existe.
'O DirName pode ser um caminho absoluto ou relativo.
Public Function FolderExists(ByVal DirName)

	On Error Resume Next
  If Mid(DirName, 2, 1) <> ":" Then
    DirName = Server.MapPath(DirName)
  End If	
  On Error GoTo 0
	
	Dim fso
	Set fso = Server.CreateObject("Scripting.FileSystemObject")
	FolderExists = fso.FolderExists(DirName)
	Set fso = Nothing
	
End Function



'L o contedo de uma pasta e retorna uma array de arrays.
'A array retornada tem essa estrutura:
'     Arr(...)(0) => Nome do objeto
'     Arr(...)(1) => Caminho fsico completo do objeto
'     Arr(...)(2) => Tipo de objeto (1 = arquivo, 2 = pasta)
'Retorna Null se ocorrer erro.
'O DirName pode ser um caminho absoluto ou relativo.

Function ReadDir(ByVal DirName)
  
  On Error Resume Next
  
  If Mid(DirName, 2, 1) <> ":" Then
    DirName = Server.MapPath(DirName)
  End If
  If Err Then Err.Clear
  
  On Error GoTo 0
  
	Dim FSO, D
	Dim Arr, i, El, Aux(2)
	
	Arr = Array()
	i = -1
	
	Set FSO = Server.CreateObject("Scripting.FileSystemObject")
	
	On Error Resume Next
	
	Set D = FSO.GetFolder(DirName)
	If Err Then
		Set FSO = Nothing
		ReadDir = Null
		Exit Function
	End If
	
	On Error GoTo 0
	
	For Each El In D.SubFolders
		Aux(0) = El.Name
		Aux(1) = El.Path
		Aux(2) = 2
		i = i + 1
		ReDim Preserve Arr(i)
		Arr(i) = Aux
	Next
	
	For Each El In D.Files
		Aux(0) = El.Name
		Aux(1) = El.Path
		Aux(2) = 1
		i = i + 1
		ReDim Preserve Arr(i)
		Arr(i) = Aux
	Next
	
	Set D = Nothing
	Set FSO = Nothing
	ReadDir = Arr
	
End Function


'Cria uma pasta.
'O DirName pode ser um caminho absoluto ou relativo.
Public Function CreateFolder(ByVal DirName)
	
	On Error Resume Next
  If Mid(DirName, 2, 1) <> ":" Then
    DirName = Server.MapPath(DirName)
  End If
  If Err Then Err.Clear
  On Error GoTo 0
	
	Dim FSO
	Set FSO = Server.CreateObject("Scripting.FileSystemObject")
	
	On Error Resume Next
	If FSO.FolderExists(DirName) Then
		FSO.DeleteFolder DirName
	End If
	
	If Err Then
		On Error GoTo 0
		CreateFolder = False
		Set FSO = Nothing
		Exit Function
	End If
	
	FSO.CreateFolder DirName
	If Err Then
		On Error GoTo 0
		CreateFolder = False
		Set FSO = Nothing
		Exit Function
	End If
	
	On Error GoTo 0
	Set FSO = Nothing
	CreateFolder = True
	
End Function


'Obtm um arquivo e retorna um objeto File.
'O FileName pode ser um caminho absoluto ou relativo.
Function GetFile(ByVal FileName)
  
  On Error Resume Next
  
  If Mid(FileName, 2, 1) <> ":" Then
    FileName = Server.MapPath(FileName)
  End If
  If Err Then Err.Clear
  
  On Error GoTo 0
  
	Dim FSO
	Set FSO = Server.CreateObject("Scripting.FileSystemObject")
	
	On Error Resume Next
	
	Set GetFile = FSO.GetFile(FileName)
	If Err Then
		Err.Clear
		Set GetFile = Nothing
	End If
	
	On Error GoTo 0
	
	Set FSO = Nothing
	
End Function


'Retorna a extenso do arquivo em um caminho
Function GetFileExt(ByVal p)
	GetFileExt = Right(p, Len(p) - InStrRev(p, "."))
End Function


'Obtm uma pasta e retorna um objeto Folder.
'O FolderName pode ser um caminho absoluto e relativo.
Function GetFolder(ByVal FolderName)
  
  On Error Resume Next
  
  If Mid(FolderName, 2, 1) <> ":" Then
    FolderName = Server.MapPath(FolderName)
  End If
  If Err Then Err.Clear
  
  On Error GoTo 0
  
	Dim FSO
	Set FSO = Server.CreateObject("Scripting.FileSystemObject")
	
	On Error Resume Next
	
	Set GetFolder = FSO.GetFolder(FolderName)
	If Err Then
		Err.Clear
		Set GetFolder = Nothing
	End If
	
	On Error GoTo 0
	Set FSO = Nothing
	
End Function


'Obtm as propriedades de um arquivo e retorna
'um objeto dicionrio. No esquecer de liberar o objeto depois de us-lo.
Function GetFileProps(ByVal FileName)
  
  On Error Resume Next
  
  If Mid(FileName, 2, 1) <> ":" Then
    FileName = Server.MapPath(FileName)
  End If
  If Err Then Err.Clear
  
  On Error GoTo 0
  
	Dim FSO, F, D
	Set FSO = Server.CreateObject("Scripting.FileSystemObject")
	
	On Error Resume Next
	
	Set F = FSO.GetFile(FileName)
	
	If Err Then
		Err.Clear
		Set FSO = Nothing
		FileStats = Null
		On Error GoTo 0
		Exit Function
	End If
	
	On Error GoTo 0
	
	Set D = Server.CreateObject("Scripting.Dictionary")
	
	D.Add "DateCreated", F.DateCreated
	D.Add "DateLastAccessed", F.DateLastAccessed
	D.Add "DateLastModified", F.DateLastModified
	D.Add "Size", F.Size
	D.Add "Name", F.Name
	
	Set F = Nothing
	Set FSO = Nothing
	Set GetFileProps = D
	Set D = Nothing
	
End Function


'Retorna o nome de arquivo em um caminho.
Function GetFileName(ByVal Path)
	Path = Replace(Path, "/", "\")
	GetFileName = Right(Path, Len(Path) - InStrRev(Path, "\"))
End Function


'Conta o nmero de linhas em um arquivo.
Function FileCountLines(ByVal FileName)
	
	Dim sStream	
	Dim iLines
	Dim i, j, k
	
	If Mid(FileName, 2, 1) <> ":" Then
		FileName = Server.MapPath(FileName)
	End If
	sStream = ReadFile(FileName)
	
	i = 1
	j = 1
	iLines = 0
	k = Len(sStream)
	
	Do While i <= k
		i = InStr(i, sStream, vbCrLf)		
		If i = 0 Then Exit Do
		iLines = iLines + 1
		i = i + 2
	Loop
	
	If iLines > 0 Then iLines = iLines + 1
	FileCountLines = iLines
	
End Function

	

'Retorna uma array contendo os seguintes dados:
'	Array(0) => Nmero de subpastas
'	Array(1) => Nmero de arquivos
'	Array(2) => Espao total em disco
Function DirCount(ByVal DirName)
  
  On Error Resume Next
  
  If Mid(DirName, 2, 1) <> ":" Then
    DirName = Server.MapPath(DirName)
  End If
  If Err Then Err.Clear
  
  On Error GoTo 0
  
	Dim FSO, D, El
	Dim Arr(2), Aux
	
	Set FSO = Server.CreateObject("Scripting.FileSystemObject")
	
	On Error Resume Next
	
	Set D = FSO.GetFolder(DirName)
	If Err Then
		Err.Clear
		Set FSO = Nothing
		DirCount = Null
		On Error GoTo 0
		Exit Function
	End If
	
	On Error GoTo 0
	
	Arr(0) = 0
	Arr(1) = 0
	Arr(2) = 0
	
	For Each El In D.Files
		Arr(1) = Arr(1) + 1
		Arr(2) = Arr(2) + El.Size
	Next
	
	For Each El In D.SubFolders
		Arr(0) = Arr(0) + 1
		Aux = DirCount(El.Path)
		Arr(0) = Arr(0) + Aux(0)
		Arr(1) = Arr(1) + Aux(1)
		Arr(2) = Arr(2) + Aux(2)
	Next
	
	Set D = Nothing
	Set FSO = Nothing
	DirCount = Arr
	
End Function


'Retorna o caminho relativo do script atual.
Function AspSelf()
	AspSelf = Request.ServerVariables("SCRIPT_NAME")
End Function


'Retorna o caminho fsico da pasta atual.
Function CurrentFolder()
	Dim f
	f = AspSelf()
	f = Left(f, InStrRev(f, "/") -1)
	CurrentFolder = Server.MapPath(f)
End Function


'Mapeia o caminho relativo para um arquivo a partir da pasta atual.
Function GetRelativePath(ByVal FileName)
	
	On Error Resume Next
  
  If Mid(FileName, 2, 1) <> ":" Then
    FileName = Server.MapPath(FileName)
  End If
  If Err Then Err.Clear
  
  On Error GoTo 0
  
	Dim a, b, a1, b1
	Dim i, Str, j
	
	a = Server.MapPath(AspSelf())
	b = FileName
	a = Split(a, "\")
	b = Split(b, "\")
	a1 = UBound(a)
	b1 = UBound(b)
	
	i = 0
	Str = ""
	
	Do While i <= a1 And i <= b1
		If LCase(a(i)) <> LCase(b(i)) Then
			For j = 0 To a1 - i - 1
				Str = Str & "../"
			Next
			For j = i To b1
				Str = Str & b(j)
				If j <> b1 Then Str = Str & "/"
			Next
			GetRelativePath = Str
			Exit Function
		End If
		i = i + 1
	Loop
	
	While i <= b1
		Str = Str & b(i)
		If i < b1 Then Str = Str & "/"
		i = i + 1
	Wend
	
	If Str = "" Then Str = a(a1)	
	GetRelativePath = Str
	
End Function


'Mapeia o caminho relativo para a raiz do site a partir da pasta atual.
Public Function MapRoot()
	
	Dim MyPath, MyRoot
	Dim MyArray
	Dim i, j
	
	MyPath = AspSelf()
	MyRoot = ""
	MyArray = Split(MyPath, "/")
	j = UBound(MyArray) - 2
	
	For i = j To 0 Step -1
		MyRoot = MyRoot & "../"
	Next
	
	MapRoot = MyRoot
	
End Function


'Escreve uma mensagem e mata o script.
Sub Die(ByVal Str)
	Response.Write Str
	Response.End
End Sub

Sub JsBack(ByVal Msg)
	With Response
		If .Buffer Then .Clear
		.Write "<" & "script type=""text/javascript"" language=""javascript""" & ">" & vbCrLf
		.Write "<!--" & vbCrLf
		If Msg <> "" Then .Write "alert(""" & Msg & """);" & vbCrLf
		.Write "history.back();" & vbCrLf
		.Write "//-->" & vbCrLf
		.Write "<" & "/script" & ">" & vbCrLf
		.End
	End With
End Sub

Sub JsGo(ByVal Msg, ByVal Url)
	With Response
		If .Buffer Then .Clear
		.Write "<" & "script type=""text/javascript"" language=""javascript""" & ">" & vbCrLf
		.Write "<!--" & vbCrLf
		If Msg <> "" Then .Write "alert(""" & Msg & """);" & vbCrLf
		.Write "location.href = """ & Url & """;" & vbCrLf
		.Write "//-->" & vbCrLf
		.Write "<" & "/script" & ">" & vbCrLf
		.End
	End With
End Sub

Sub JsClose(ByVal Msg)
	With Response
		If .Buffer Then .Clear
		.Write "<" & "script type=""text/javascript"" language=""javascript""" & ">" & vbCrLf
		.Write "<!--" & vbCrLf
		If Msg <> "" Then .Write "alert(""" & Msg & """);" & vbCrLf
		.Write "try { window.opener.focus() }" & vbCrLf
		.Write "catch(err) {}" & vbCrLf
		.Write "finally { window.close() }" & vbCrLf
		.Write "//-->" & vbCrLf
		.Write "<" & "/script" & ">" & vbCrLf
		.End
	End With
End Sub

Function Implode(ByVal Separator, ByRef Arr)
	Dim Str, i, ub
	Str = ""
	ub = UBound(Arr)
	For i = 0 To ub
		If Str <> "" Then Str = Str & Separator
		Str = Str & Arr(i)
	Next
	Implode = Str
End Function

Function DateCheck(ByVal Data)
 
  If Not IsDate(Data) Then
    DateCheck = False
    Exit Function
  End If
  
  Dim Ano, Mes, Dia
  Dim Hora, Minuto, Segundo
  Dim AnoAtual
  
  Ano = Year(Data)
  Mes = Month(Data)
  Dia = Day(Data)
  Hora = Hour(Data)
  Minuto = Minute(Data)
  Segundo = Second(Data)
  
  AnoAtual = Year(Date)
  
  If Ano < (AnoAtual - 100) Or Ano > (AnoAtual + 100) Then
    DateCheck = False
    Exit Function
  End If
  
  If Mes < 1 Or Mes > 12 Then
    DateCheck = False
    Exit Function
  End If
  
  If Dia < 1 Or Dia > 31 Then
    DateCheck = False
    Exit Function
  End If
  
  If Hora < 0 Or Hora > 23 Then
    DateCheck = False
    Exit Function
  End If
  
  If Minuto < 0 Or Minuto > 59 Then
    DateCheck = False
    Exit Function
  End If
  
  If Segundo < 0 Or Segundo > 59 Then
    DateCheck = False
    Exit Function
  End If
  
  If Mes = 2 Then
    If Ano Mod 4 = 0 Then
      If Dia > 29 Then
        DateCheck = False
        Exit Function
      End If
    ElseIf Dia > 28 Then
      DateCheck = False
      Exit Function
    End If
  End If
  
  DateCheck = True
  
End Function



'Formata uma data. As mscaras suportadas so:
'   yy         Ano com 2 dgitos
'   yyyy       Ano com 4 dgitos
'   mm         Ms de 01 a 12
'   dd         Dia de 01 a 31
'   hh         Hora de 00 a 23
'   ii         Minuto de 00 a 59
'   ss         Segundo de 00 a 59

Function DateFormat(ByVal Format, ByVal dtVariant)

	Dim y2, y4, m, d
	Dim h, i, s
	dtVariant = CDate(dtVariant)
	
	y4 = Year(dtVariant)   & ""
	m  = Month(dtVariant)  & ""
	d  = Day(dtVariant)    & ""
	h  = Hour(dtVariant)   & ""
	i  = Minute(dtVariant) & ""
	s  = Second(dtVariant) & ""
	
	y2 = Right(y4, 2)
	If Len(m) = 1 Then m = "0" & m
	If Len(d) = 1 Then d = "0" & d
	If Len(h) = 1 Then h = "0" & h
	If Len(i) = 1 Then i = "0" & i
	If Len(s) = 1 Then s = "0" & s
	
	Format = Replace(Format, "yyyy", y4)
	Format = Replace(Format, "yy", y2)
	Format = Replace(Format, "mm", m)
	Format = Replace(Format, "dd", d)
	Format = Replace(Format, "hh", h)
	Format = Replace(Format, "ii", i)
	Format = Replace(Format, "ss", s)
	
	DateFormat = Format
	
End Function


Function Hex2Int(ByVal hStr)

	If Not eregi("^[a-f0-9]*$", hStr) Then
		Err.Raise 1002, "ASP Util Library", "Hex2Int: Invalid argument: " & hStr
	End If
	
	Dim h, D, i
	Dim c, ln
	
	h = 0
	ln = Len(hStr)
	Set D = Server.CreateObject("Scripting.Dictionary")	
	
	For i = 0 To 9
		D.Add i & "", i
	Next
	For i = 65 To 70
		D.Add Chr(i), i - 55
	Next
	
	For i = ln To 1 Step -1
		c = UCase(Mid(hStr, i, 1))
		h = h + ( D(c) * ( 16 ^ (ln - i) ) )
	Next
	
	Set D = Nothing
	Hex2Int = h
	
End Function


Function NumberFormat(ByVal sExpr)
	
	sExpr = sExpr & ""
	If ereg("^[0-9]{1,2}/[0-9]{1,2}/[0-9]{4}$", sExpr) Then
		sExpr = CDbl(CDate(sExpr)) & ""
	ElseIf Not IsNumeric(sExpr) Then
		NumberFormat = "0"
		Exit Function
	End If
	
	sExpr = Replace(sExpr, ",", ".")	
	NumberFormat = sExpr
	
End Function


Function StripTags(ByRef Str)
	
	Str = Str & ""
	If Str = "" Then
		StripTags = ""
		Exit Function
	End If
	
	Dim nw, i, j, c, k, x

	i = 1
	x = 1
	k = Len(Str)
	nw = ""
	
	Do While i > 0
	
		i = InStr(i, Str, "<")
		If i = 0 Then Exit Do
		
		j = InStr(i, Str, ">")
		If j < i Then Exit Do
		
		c = Mid(Str, i + 1, 1)
		If ereg("^[a-zA-Z/!]$", c) Then
			nw = nw & Mid(Str, x, i - x)
			i = j + 1
			x = i
		Else
			i = i + 1
		End If
		
		If i >= k Then Exit Do
		
	Loop
	
	nw = nw & Mid(Str, x, k - x + 1)
	StripTags = nw
	
End Function


Function TrimChop(ByVal Str)
	Dim i, rm, c, nw, a
	Str = Trim(Str)
	nw = ""
	rm = False
	For i = 1 To Len(Str)
		c = Mid(Str, i, 1)
		a = Asc(c)
		If a < 33 Or a = 160 Then
			If Not rm Then
				rm = True
				nw = nw & c
			End If
		Else
			rm = False
			nw = nw & c
		End If
	Next
	TrimChop = nw
End Function


Function NoScripts(ByVal Str)

	Dim op(3), cl(3)
	Dim i, nw, j, k, ln
	
	op(0) = "<" & "%"
	op(1) = "<" & "?"
	op(2) = "<" & "script"
	op(3) = "<" & "style"
	
	cl(0) = "%" & ">"
	cl(1) = "?" & ">"
	cl(2) = "<" & "/script>"
	cl(3) = "<" & "/style>"
	
	For j = 0 To UBound(op)
		i = 1
		Do While i > 0
			i = InStr(i, Str, op(j), 1)
			If i = 0 Then Exit Do
			k = InStr(i, Str, cl(j), 1)
			If k < i Then Exit Do
			
			ln = Len(cl(j))
			nw = Left(Str, i - 1) & Mid(Str, k + ln, Len(Str) - (k + ln) + 1)
			Str = nw
			i = 1
		Loop
	Next
	
	NoScripts = Str
	
End Function


Function GetTitle(ByRef Str)
	Dim i, j, k
	i = InStr(1, Str, "<title", 1)
	If i = 0 Then
		GetTitle = ""
		Exit Function
	End If
	j = InStr(i, Str, "</title>", 1)
	If j < i Then
		GetTitle = ""
		Exit Function
	End If
	k = InStr(i + 1, Str, ">")
	If k < i Or k > j Then
		GetTitle = ""
		Exit Function
	End If
	GetTitle = Mid(Str, k + 1, j - (k + 1))
	GetTitle = TrimChop(NoScripts(StripTags(GetTitle)))
End Function


'Obtm todas as tags <A> e retorna uma array de arrays com essa estrutura:
'    Arr(...)(0) ->  Texto dentro da tag
'    Arr(...)(1) ->  Atributo HREF

Function GetLinks(ByRef Str)

	Dim i, j, k, m, n, a
	Dim Links, b, Itens(1)
	
	Links = Array()
	b = -1	
	i = 1 : j = 1 : k = 1
	
	Do While i > 0
	
		i = InStr(i, Str, "<a", 1)
		If i = 0 Then Exit Do
		
		j = InStr(i, Str, ">")
		If j = 0 Then Exit Do
		
		k = InStr(j, Str, "</a>", 1)
		If k = 0 Then Exit Do
		
		n = InStr(i, Str, " href=", 1)
		If n = 0 Or n > j Then Exit Do
		
		
		a = Mid(Str, n + 6, 1)
		If a = "'" Or a = """" Then
			m = InStr(n + 7, Str, a)
			If m = 0 Or m > j Then Exit Do
			Itens(1) = Mid(Str, n + 7, m - (n + 7))
		Else
			m = InStr(n + 7, Str, " ")
			If m = 0 Or m > j Then m = j
			Itens(1) = Mid(Str, n + 6, m - (n + 6))
		End If		
		Itens(0) = TrimChop(StripTags(Mid(Str, j + 1, k - (j + 1))))
		
		b = b + 1
		ReDim Preserve Links(b)
		Links(b) = Itens
		
		i = i + 1
		
	Loop
	
	GetLinks = Links			

End Function


'Decodifica uma string HTML.
'Substitui caracteres codificados pela correspondncia em ASCII.
Function HTMLDecode(ByRef Str)

	Dim i, j, c, t, d
	Dim s
	
	s = ""
	t = Len(Str)
	i = 1
	
	Do While i <= t
		c = Mid(Str, i, 1)
		If c <> "&" Then
			s = s & c
			i = i + 1
		Else
			If Mid(Str, i + 1, 1) = "#" Then
				j = InStr(i, Str, ";")
				If j = 0 Then
					s = s & c
					i = i + 1
				Else
					d = Mid(Str, i + 2, j - (i + 2))
					If ereg("^[0-9]+$", d) Then
						d = CInt(d)
						If d > 0 And d < 256 Then
							s = s & Chr(d)
							i = j + 1
						Else
							s = s & c
							i = i + 1
						End If
					Else
						s = s & c
						i = i + 1
					End If
				End If
			Else
				j = InStr(i, Str, ";")
				If j = 0 Then
					s = s & c
					i = i + 1
				Else
					d = Mid(Str, i + 1, j - (i + 1))
					Select Case d
					Case "aacute"
						s = s & ""
						i = j + 1
					Case "Aacute"
						s = s & ""
						i = j + 1
					Case "eacute"
						s = s & ""
						i = j + 1
					Case "Eacute"
						s = s & ""
						i = j + 1
					Case "iacute"
						s = s & ""
						i = j + 1
					Case "Iacute"
						s = s & ""
						i = j + 1
					Case "oacute"
						s = s & ""
						i = j + 1
					Case "Oacute"
						s = s & ""
						i = j + 1
					Case "uacute"
						s = s & ""
						i = j + 1
					Case "Uacute"
						s = s & ""
						i = j + 1
					Case "agrave"
						s = s & ""
						i = j + 1
					Case "Agrave"
						s = s & ""
						i = j + 1
					Case "egrave"
						s = s & ""
						i = j + 1
					Case "Egrave"
						s = s & ""
						i = j + 1
					Case "igrave"
						s = s & ""
						i = j + 1
					Case "Igrave"
						s = s & ""
						i = j + 1
					Case "ograve"
						s = s & ""
						i = j + 1
					Case "Ograve"
						s = s & ""
						i = j + 1
					Case "ugrave"
						s = s & ""
						i = j + 1
					Case "Ugrave"
						s = s & ""
						i = j + 1
					Case "atilde"
						s = s & ""
						i = j + 1
					Case "Atilde"
						s = s & ""
						i = j + 1
					Case "otilde"
						s = s & ""
						i = j + 1
					Case "Otilde"
						s = s & ""
						i = j + 1
					Case "ntilde"
						s = s & ""
						i = j + 1
					Case "Ntilde"
						s = s & ""
						i = j + 1
					Case "acirc"
						s = s & ""
						i = j + 1
					Case "Acirc"
						s = s & ""
						i = j + 1
					Case "ecirc"
						s = s & ""
						i = j + 1
					Case "icirc"
						s = s & ""
						i = j + 1
					Case "Icirc"
						s = s & ""
						i = j + 1
					Case "ocirc"
						s = s & ""
						i = j + 1
					Case "Ocirc"
						s = s & ""
						i = j + 1
					Case "ucirc"
						s = s & ""
						i = j + 1
					Case "Ucirc"
						s = s & ""
						i = j + 1
					Case "yacute"
						s = s & ""
						i = j + 1
					Case "Yacute"
						s = s & ""
						i = j + 1
					Case "auml"
						s = s & ""
						i = j + 1
					Case "Auml"
						s = s & ""
						i = j + 1
					Case "euml"
						s = s & ""
						i = j + 1
					Case "Euml"
						s = s & ""
						i = j + 1
					Case "iuml"
						s = s & ""
						i = j + 1
					Case "Iuml"
						s = s & ""
						i = j + 1
					Case "ouml"
						s = s & ""
						i = j + 1
					Case "Ouml"
						s = s & ""
						i = j + 1
					Case "uuml"
						s = s & ""
						i = j + 1
					Case "Uuml"
						s = s & ""
						i = j + 1
					Case "copy"
						s = s & ""
						i = j + 1
					Case "reg"
						s = s & ""
						i = j + 1
					Case "lt"
						s = s & "<"
						i = j + 1
					Case "gt"
						s = s & ">"
						i = j + 1
					Case "amp"
						s = s & "&"
						i = j + 1
					Case "quot"
						s = s & """"
						i = j + 1
					Case "AElig"
						s = s & ""
						i = j + 1
					Case "ccedil"
						s = s & ""
						i = j + 1
					Case "Ccedil"
						s = s & ""
						i = j + 1
					Case "ETH"
						s = s & ""
						i = j + 1
					Case "Oslash"
						s = s & ""
						i = j + 1
					Case "THORN"
						s = s & ""
						i = j + 1
					Case "aelig"
						s = s & ""
						i = j + 1
					Case "aring"
						s = s & ""
						i = j + 1
					Case "Aring"
						s = s & ""
						i = j + 1
					Case "eth"
						s = s & ""
						i = j + 1
					Case "oslash"
						s = s & ""
						i = j + 1
					Case "szlig"
						s = s & ""
						i = j + 1
					Case "thorn"
						s = s & ""
						i = j + 1
					Case "yuml"
						s = s & ""
						i = j + 1
					Case "nbsp"
						s = s & Chr(160)
						i = j + 1
					Case Else
						s = s & c
						i = i + 1
					End Select
				End If
			End If
		End If
	Loop
	
	HTMLDecode = s				

End Function


Public Function UnEscape(ByVal Str)	
	Dim i, Nova, h, j, c, ln	
	For i = 1 To 255
		h = Hex(i)
		If Len(h) = 1 Then h = "0" & h
		h = "%" & h
		Str = eregi_replace(h, Chr(i), Str)
	Next	
	UnEscape = Str	
End Function




%>
